Bug 1420723 - gcc: Missing nop instruction after recursive call corrupts TOC register on ppc64le
Summary: gcc: Missing nop instruction after recursive call corrupts TOC register on pp...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: gcc
Version: 7.3
Hardware: ppc64le
OS: Linux
low
low
Target Milestone: rc
: ---
Assignee: Jakub Jelinek
QA Contact: Michael Petlan
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-02-09 12:00 UTC by Florian Weimer
Modified: 2017-08-01 22:35 UTC (History)
3 users (show)

Fixed In Version: gcc-4.8.5-12.el7
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-08-01 22:35:59 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
GNU Compiler Collection 79439 0 None None None 2017-02-09 12:01:18 UTC
Red Hat Product Errata RHBA-2017:2094 0 normal SHIPPED_LIVE gcc bug fix update 2017-08-01 19:36:07 UTC
Sourceware 21116 0 None None None 2017-02-09 12:01:35 UTC

Description Florian Weimer 2017-02-09 12:00:54 UTC
GCC incorrectly assumes that recursive calls are always local, and elides a nop instruction after a recursive call (which is otherwise required by the ABI).

This code generation issue affects the interposition of recursive functions and can lead to crashes if the original function is called by different means (e.g. through dlsym).  The recursive call ends up calling the interposing function in a different module, but the TOC is not restored afterwards.

Details in the upstream bug report:

  https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79439

Originally reported against glibc:

  https://sourceware.org/bugzilla/show_bug.cgi?id=21116

Comment 2 Michael Petlan 2017-05-31 14:17:39 UTC
The related test passes on both ppc64 and ppc64le with gcc-4.8.5-14.el7.
VERIFIED.

Comment 3 errata-xmlrpc 2017-08-01 22:35:59 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2017:2094


Note You need to log in before you can comment on or make changes to this bug.